<template>
  <el-main>
    <!--现 场 检 查（勘 验）笔 录-->
    <el-form ref="dataForm" :model="dataForm" :label-width="formLabelWidth" :disabled="isFinish =='2'">
        <el-row>
          <el-col :span="12">
            <el-form-item label="开始时间">
              <el-date-picker
                v-model="dataForm.startTime"
                type="datetime"
                :value-format="`yyyy-MM-dd HH:mm:ss`"
                placeholder="选择日期时间"
                style="width: 100%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="结束时间">
              <el-date-picker
                v-model="dataForm.endTime"
                type="datetime"
                :value-format="`yyyy-MM-dd HH:mm:ss`"
                placeholder="选择日期时间"
                style="width: 100%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      <el-form-item label="地点">
        <el-input v-model="dataForm.site"></el-input>
      </el-form-item>
      <h1 style="text-align: center;font-weight: bold;font-size: 20px;">当事人</h1>
      <el-form-item label="被检查单位名称">
        <el-input v-model="dataForm.inquestName"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="法定代表人">
            <el-input v-model="dataForm.principalName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="信用代码">
            <el-input v-model="dataForm.creditCode"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="当事人姓名">
            <el-input v-model="dataForm.reviewedName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="性别">
            <el-select v-model="dataForm.reviewedSex" placeholder="请选择性别" style="width: 100%">
              <el-option
                v-for="item in reviewedSexs"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>

      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="身份证号">
            <el-input v-model="dataForm.reviewedCardNo"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="职务">
            <el-input v-model="dataForm.reviewedDuty"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="电话">
            <el-input v-model="dataForm.reviewedPhone"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="邮编">
            <el-input v-model="dataForm.reviewedPostcode"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="住址">
        <el-input v-model="dataForm.reviewedAddress"></el-input>
      </el-form-item>

      <el-form-item label="工作单位">
        <el-input v-model="dataForm.reviewedUnit"></el-input>
      </el-form-item>

      <h1 style="text-align: center;font-weight: bold;font-size: 20px;">见证人</h1>
      <el-row>
        <el-col :span="12">
          <el-form-item label="姓名">
            <el-input v-model="dataForm.eyewitnessName"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="电话">
            <el-input v-model="dataForm.eyewitnessPhone"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="职位">
            <el-input v-model="dataForm.eyewitnessDuty"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="身份证号">
            <el-input v-model="dataForm.eyewitnessCardNo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="单位及住址">
        <el-input v-model="dataForm.eyewitnessUnit"></el-input>
      </el-form-item>

      <h2 style="text-align: center;font-weight: bold;font-size: 20px;">检查及记录人</h2>
      <el-row>
        <el-col :span="12">
          <el-form-item label="检查人1">
            <el-input v-model="dataForm.checkerNameOne"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执行证号">
            <el-input v-model="dataForm.inquisitorialNameOne"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="检查人2">
            <el-input v-model="dataForm.checkerNameTwo"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执行证号">
            <el-input v-model="dataForm.inquisitorialNameTwo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="记录人">
        <el-input v-model="dataForm.recorderName"></el-input>
      </el-form-item>
      <el-form-item label="案件名称">
        <el-input v-model="dataForm.caseName"></el-input>
      </el-form-item>
      <el-form-item label="现场情况">
        <el-input type="textarea" v-model="dataForm.currentSituation"></el-input>
      </el-form-item>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center;">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(dataForm)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(dataForm)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import {getObj, saveObj} from '@/api/News/chechCause'
import WordView from '@/views/News/word-view/index'
import moment from "moment";
import {remote} from "@/api/admin/dict"

export default {
  name: "chech_cause",
  props: ['isShowYulan', 'id', 'isFinish', 'processId'],
  components: {
    WordView
  },
  data() {
    return {
      showView: false,
      dataForm: {
        startTime: '',
        endTime: '',
        site: '',
        inquestName: '',
        principalName: '',
        creditCode: '',
        reviewedName: '',
        reviewedSex: '',
        reviewedDuty: '',
        reviewedCardNo: '',
        reviewedPhone: '',
        reviewedAddress: '',
        reviewedPostcode: '',
        reviewedUnit: '',
        eyewitnessName: '',
        eyewitnessPhone: '',
        eyewitnessCardNo: '',
        eyewitnessUnit: '',
        eyewitnessDuty: '',
        checkerNameOne: '',
        inquisitorialNameOne: '',
        checkerNameTwo: '',
        inquisitorialNameTwo: '',
        recorderName: '',
        caseName: '',
        currentSituation: '',
      },
      reviewedSexs: [],
      formLabelWidth: "140px",
    }
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      //查询证件类型字典
      remote('sex').then(res => {
        this.reviewedSexs = res.data.data;
      });
      getObj(this.id).then((res) => {
        // if (res.success) {
        // 转换null为""
        /*let v = res.result;
        for (let attr in v) {
          if (v[attr] == null) {
            v[attr] = "";
          }
        }
        let str = JSON.stringify(v);
        let data = JSON.parse(str);*/
        this.dataForm = res.data.data;
        console.log(this.dataForm, '112346')
        // }
      });
    },
    dataFormSubmit(type) {
      console.log(this.dataForm, '112345')
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.dataForm.registerState = type;
              obj.dataForm.registerId = obj.id;
              obj.dataForm.processId = obj.processId;
              saveObj(obj.dataForm).then((res) => {
                if (res.data.code == 0) {
                  obj.$message.success("操作成功");
                  obj.cancel();
                  obj.$emit('getDataList');
                }
              })
            })
          } else {
            obj.dataForm.registerState = type;
            obj.dataForm.registerId = obj.id;
            obj.dataForm.processId = obj.processId;
            saveObj(obj.dataForm).then((res) => {
              if (res.data.code == 0) {
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              }
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false)
    },
    cancelWord() {
      this.showView = false;
      delete this.dataForm.isTime;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      if (data.startTime == '' || data.startTime == null) {

      } else {
        let a = data.startTime.split('');
        let b = a[0] + a[1] + a[2] + a[3] + a[4] + a[5] + a[6] + a[7] + a[8] + a[9]
        data['isTime'] = b
      }
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/chechCause.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      if (data.startTime == '' || data.startTime == null) {

      } else {
        let a = data.startTime.split('');
        let b = a[0] + a[1] + a[2] + a[3] + a[4] + a[5] + a[6] + a[7] + a[8] + a[9]
        data['isTime'] = b
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/chechCause.docx", "现场检查（勘验）笔录.docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.startTime != '' && data.startTime != null) {
        data.startTime = moment(data.startTime).format('YYYY年MM月DD日HH时mm分');
      } else {
        data.startTime = '  年  月  日  时  分'
      }

      if (data.endTime != '' && data.endTime != null) {
        data.endTime = moment(data.endTime).format('HH时mm分');
      } else {
        data.endTime = '  时  分'
      }
      return data;
    }
  }
}
</script>

<style scoped>

</style>
